# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class AttemptLimitsNotificationRecallEntry(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AttemptLimitsNotificationRecallEntry - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'nbr_attempts': 'int',
            'minutes_between_attempts': 'int',
            'additional_properties': 'object'
        }

        self.attribute_map = {
            'nbr_attempts': 'nbrAttempts',
            'minutes_between_attempts': 'minutesBetweenAttempts',
            'additional_properties': 'additionalProperties'
        }

        self._nbr_attempts = None
        self._minutes_between_attempts = None
        self._additional_properties = None

    @property
    def nbr_attempts(self):
        """
        Gets the nbr_attempts of this AttemptLimitsNotificationRecallEntry.


        :return: The nbr_attempts of this AttemptLimitsNotificationRecallEntry.
        :rtype: int
        """
        return self._nbr_attempts

    @nbr_attempts.setter
    def nbr_attempts(self, nbr_attempts):
        """
        Sets the nbr_attempts of this AttemptLimitsNotificationRecallEntry.


        :param nbr_attempts: The nbr_attempts of this AttemptLimitsNotificationRecallEntry.
        :type: int
        """
        
        self._nbr_attempts = nbr_attempts

    @property
    def minutes_between_attempts(self):
        """
        Gets the minutes_between_attempts of this AttemptLimitsNotificationRecallEntry.


        :return: The minutes_between_attempts of this AttemptLimitsNotificationRecallEntry.
        :rtype: int
        """
        return self._minutes_between_attempts

    @minutes_between_attempts.setter
    def minutes_between_attempts(self, minutes_between_attempts):
        """
        Sets the minutes_between_attempts of this AttemptLimitsNotificationRecallEntry.


        :param minutes_between_attempts: The minutes_between_attempts of this AttemptLimitsNotificationRecallEntry.
        :type: int
        """
        
        self._minutes_between_attempts = minutes_between_attempts

    @property
    def additional_properties(self):
        """
        Gets the additional_properties of this AttemptLimitsNotificationRecallEntry.


        :return: The additional_properties of this AttemptLimitsNotificationRecallEntry.
        :rtype: object
        """
        return self._additional_properties

    @additional_properties.setter
    def additional_properties(self, additional_properties):
        """
        Sets the additional_properties of this AttemptLimitsNotificationRecallEntry.


        :param additional_properties: The additional_properties of this AttemptLimitsNotificationRecallEntry.
        :type: object
        """
        
        self._additional_properties = additional_properties

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

