# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class ConversationNotificationDisconnectReason(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ConversationNotificationDisconnectReason - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'type': 'str',
            'code': 'int',
            'phrase': 'str'
        }

        self.attribute_map = {
            'type': 'type',
            'code': 'code',
            'phrase': 'phrase'
        }

        self._type = None
        self._code = None
        self._phrase = None

    @property
    def type(self):
        """
        Gets the type of this ConversationNotificationDisconnectReason.


        :return: The type of this ConversationNotificationDisconnectReason.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this ConversationNotificationDisconnectReason.


        :param type: The type of this ConversationNotificationDisconnectReason.
        :type: str
        """
        allowed_values = ["Q_850", "SIP"]
        if type.lower() not in map(str.lower, allowed_values):
            # print "Invalid value for type -> " + type
            self._type = "outdated_sdk_version"
        else:
            self._type = type

    @property
    def code(self):
        """
        Gets the code of this ConversationNotificationDisconnectReason.


        :return: The code of this ConversationNotificationDisconnectReason.
        :rtype: int
        """
        return self._code

    @code.setter
    def code(self, code):
        """
        Sets the code of this ConversationNotificationDisconnectReason.


        :param code: The code of this ConversationNotificationDisconnectReason.
        :type: int
        """
        
        self._code = code

    @property
    def phrase(self):
        """
        Gets the phrase of this ConversationNotificationDisconnectReason.


        :return: The phrase of this ConversationNotificationDisconnectReason.
        :rtype: str
        """
        return self._phrase

    @phrase.setter
    def phrase(self, phrase):
        """
        Sets the phrase of this ConversationNotificationDisconnectReason.


        :param phrase: The phrase of this ConversationNotificationDisconnectReason.
        :type: str
        """
        
        self._phrase = phrase

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

