# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class GeolocationNotification(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        GeolocationNotification - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'user_id': 'str',
            'type': 'str',
            'country': 'str',
            'region': 'str',
            'city': 'str'
        }

        self.attribute_map = {
            'user_id': 'userId',
            'type': 'type',
            'country': 'country',
            'region': 'region',
            'city': 'city'
        }

        self._user_id = None
        self._type = None
        self._country = None
        self._region = None
        self._city = None

    @property
    def user_id(self):
        """
        Gets the user_id of this GeolocationNotification.


        :return: The user_id of this GeolocationNotification.
        :rtype: str
        """
        return self._user_id

    @user_id.setter
    def user_id(self, user_id):
        """
        Sets the user_id of this GeolocationNotification.


        :param user_id: The user_id of this GeolocationNotification.
        :type: str
        """
        
        self._user_id = user_id

    @property
    def type(self):
        """
        Gets the type of this GeolocationNotification.


        :return: The type of this GeolocationNotification.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this GeolocationNotification.


        :param type: The type of this GeolocationNotification.
        :type: str
        """
        
        self._type = type

    @property
    def country(self):
        """
        Gets the country of this GeolocationNotification.


        :return: The country of this GeolocationNotification.
        :rtype: str
        """
        return self._country

    @country.setter
    def country(self, country):
        """
        Sets the country of this GeolocationNotification.


        :param country: The country of this GeolocationNotification.
        :type: str
        """
        
        self._country = country

    @property
    def region(self):
        """
        Gets the region of this GeolocationNotification.


        :return: The region of this GeolocationNotification.
        :rtype: str
        """
        return self._region

    @region.setter
    def region(self, region):
        """
        Sets the region of this GeolocationNotification.


        :param region: The region of this GeolocationNotification.
        :type: str
        """
        
        self._region = region

    @property
    def city(self):
        """
        Gets the city of this GeolocationNotification.


        :return: The city of this GeolocationNotification.
        :rtype: str
        """
        return self._city

    @city.setter
    def city(self, city):
        """
        Sets the city of this GeolocationNotification.


        :param city: The city of this GeolocationNotification.
        :type: str
        """
        
        self._city = city

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

