# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class Question(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Question - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'text': 'str',
            'help_text': 'str',
            'type': 'str',
            'weight': 'float',
            'na_required': 'bool',
            'comments_required': 'bool',
            'is_kill': 'bool',
            'is_critical': 'bool',
            'na_enabled': 'bool',
            'visibility_condition': 'VisibilityCondition',
            'answer_options': 'list[AnswerOption]'
        }

        self.attribute_map = {
            'id': 'id',
            'text': 'text',
            'help_text': 'helpText',
            'type': 'type',
            'weight': 'weight',
            'na_required': 'naRequired',
            'comments_required': 'commentsRequired',
            'is_kill': 'isKill',
            'is_critical': 'isCritical',
            'na_enabled': 'naEnabled',
            'visibility_condition': 'visibilityCondition',
            'answer_options': 'answerOptions'
        }

        self._id = None
        self._text = None
        self._help_text = None
        self._type = None
        self._weight = None
        self._na_required = None
        self._comments_required = None
        self._is_kill = None
        self._is_critical = None
        self._na_enabled = None
        self._visibility_condition = None
        self._answer_options = None

    @property
    def id(self):
        """
        Gets the id of this Question.


        :return: The id of this Question.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this Question.


        :param id: The id of this Question.
        :type: str
        """
        
        self._id = id

    @property
    def text(self):
        """
        Gets the text of this Question.


        :return: The text of this Question.
        :rtype: str
        """
        return self._text

    @text.setter
    def text(self, text):
        """
        Sets the text of this Question.


        :param text: The text of this Question.
        :type: str
        """
        
        self._text = text

    @property
    def help_text(self):
        """
        Gets the help_text of this Question.


        :return: The help_text of this Question.
        :rtype: str
        """
        return self._help_text

    @help_text.setter
    def help_text(self, help_text):
        """
        Sets the help_text of this Question.


        :param help_text: The help_text of this Question.
        :type: str
        """
        
        self._help_text = help_text

    @property
    def type(self):
        """
        Gets the type of this Question.


        :return: The type of this Question.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this Question.


        :param type: The type of this Question.
        :type: str
        """
        
        self._type = type

    @property
    def weight(self):
        """
        Gets the weight of this Question.


        :return: The weight of this Question.
        :rtype: float
        """
        return self._weight

    @weight.setter
    def weight(self, weight):
        """
        Sets the weight of this Question.


        :param weight: The weight of this Question.
        :type: float
        """
        
        self._weight = weight

    @property
    def na_required(self):
        """
        Gets the na_required of this Question.


        :return: The na_required of this Question.
        :rtype: bool
        """
        return self._na_required

    @na_required.setter
    def na_required(self, na_required):
        """
        Sets the na_required of this Question.


        :param na_required: The na_required of this Question.
        :type: bool
        """
        
        self._na_required = na_required

    @property
    def comments_required(self):
        """
        Gets the comments_required of this Question.


        :return: The comments_required of this Question.
        :rtype: bool
        """
        return self._comments_required

    @comments_required.setter
    def comments_required(self, comments_required):
        """
        Sets the comments_required of this Question.


        :param comments_required: The comments_required of this Question.
        :type: bool
        """
        
        self._comments_required = comments_required

    @property
    def is_kill(self):
        """
        Gets the is_kill of this Question.


        :return: The is_kill of this Question.
        :rtype: bool
        """
        return self._is_kill

    @is_kill.setter
    def is_kill(self, is_kill):
        """
        Sets the is_kill of this Question.


        :param is_kill: The is_kill of this Question.
        :type: bool
        """
        
        self._is_kill = is_kill

    @property
    def is_critical(self):
        """
        Gets the is_critical of this Question.


        :return: The is_critical of this Question.
        :rtype: bool
        """
        return self._is_critical

    @is_critical.setter
    def is_critical(self, is_critical):
        """
        Sets the is_critical of this Question.


        :param is_critical: The is_critical of this Question.
        :type: bool
        """
        
        self._is_critical = is_critical

    @property
    def na_enabled(self):
        """
        Gets the na_enabled of this Question.


        :return: The na_enabled of this Question.
        :rtype: bool
        """
        return self._na_enabled

    @na_enabled.setter
    def na_enabled(self, na_enabled):
        """
        Sets the na_enabled of this Question.


        :param na_enabled: The na_enabled of this Question.
        :type: bool
        """
        
        self._na_enabled = na_enabled

    @property
    def visibility_condition(self):
        """
        Gets the visibility_condition of this Question.


        :return: The visibility_condition of this Question.
        :rtype: VisibilityCondition
        """
        return self._visibility_condition

    @visibility_condition.setter
    def visibility_condition(self, visibility_condition):
        """
        Sets the visibility_condition of this Question.


        :param visibility_condition: The visibility_condition of this Question.
        :type: VisibilityCondition
        """
        
        self._visibility_condition = visibility_condition

    @property
    def answer_options(self):
        """
        Gets the answer_options of this Question.


        :return: The answer_options of this Question.
        :rtype: list[AnswerOption]
        """
        return self._answer_options

    @answer_options.setter
    def answer_options(self, answer_options):
        """
        Sets the answer_options of this Question.


        :param answer_options: The answer_options of this Question.
        :type: list[AnswerOption]
        """
        
        self._answer_options = answer_options

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

